# Scripting Reference

From Audacity Development Manual

This page lists scripting commands.

Yes these are the same commands as in the menus, same as in "Commands and Shortcuts" too, just presented differently.

- Presented in a format useful to people using:
  - Macros or
  - Python Scripting or
  - AUD-DO.
- Most of this page is automatically generated.

A few commands are intentionally omitted from the Macro Manager (such as "Close:") because they are unsuitable for use in Macros.

This table shows the items in the menus that are scriptable.

- The Scripting Ids, parameters and defaults are all likely to change between versions.
- Boolean values must be given as 1 (true) or 0 (false).

## File Menu

The File Menu provides commands for creating, opening and saving Audacity projects and importing and exporting audio files

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
New: | New | none | Creates a new empty project window, to start working on new or imported tracks.
Open: | Open... | none | Presents a standard dialog box where you can select either audio files, a list of files (.LOF) or an Audacity Project file to open.
Close: | Close | none | Closes the current project window, prompting you to save your work if you have not saved.
SaveProject: | Save Project | none | Various ways to save a project.
CompactProject: | Compact Project | none | Compact your project to save disk space.
PageSetup: | Page Setup... | none | Opens the standard Page Setup dialog box prior to printing
Print: | Print... | none | Prints all the waveforms in the current project window (and the contents of Label Tracks or other tracks), with the Timeline above. Everything is printed to one page.
Exit: | Exit | none | Closes all project windows and exits Audacity. If there are any unsaved changes to your project, Audacity will ask if you want to save them.

### File: Save Project

Various ways to save a project.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Save: | Save Project | none | Saves the current Audacity project .AUP3 file.
SaveAs: | Save Project As... | none | Same as "Save Project" above, but allows you to save a copy of an open project to a different name or location
SaveCopy: | Save Lossless Copy of Project... | none | Saves the current Audacity project .AUP3 file.
SaveCompressed: | Save Compressed Copy of Project... | none | Saves in the audacity .aup3 project file format, but compressed (Suitable for mailing)

### File: Export

For exporting audio files

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
ExportMp3: | Export as MP3 | none | Exports to an MP3 file
ExportWav: | Export as WAV | none | Exports to a WAV file
ExportOgg: | Export as OGG | none | Exports to an OGG file
Export: | Export Audio... | none | Exports to an audio file.
ExportSel: | Export Selected Audio... | none | Exports selected audio to a file.
ExportLabels: | Export Labels... | none | Exports audio at one or more labels to file(s).
ExportMultiple: | Export Multiple... | none | Exports multiple audio files in one process, one file for each track if there are multiple audio tracks, or labels can be added which then define the length of each exported file.
ExportMIDI: | Export MIDI... | none | Exports MIDI (note tracks) to a MIDI file.

### File: Import

For importing audio files or label files into your project

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
ImportAudio: | Audio... | none | Similar to 'Open', except that the file is added as a new track to your existing project.
ImportLabels: | Labels... | none | Launches a file selection window where you can choose to import a single text file into the project containing point or region labels. For more information about the syntax for labels files, see Importing and Exporting Labels.
ImportMIDI: | MIDI... | none | Imports a MIDI (MIDI or MID extension) or Allegro (GRO) file to a Note Track where simple cut-and-paste edits can be performed. The result can be exported with the File > Export> > Export MIDI command. Note: Currently, MIDI and Allegro files cannot be played.
ImportRaw: | Raw Data... | none | Attempts to import an uncompressed audio file that might be "raw" data without any headers to define its format, might have incorrect headers or be otherwise partially corrupted, or might be in a format that Audacity is unable to recognize. Raw data in textual format cannot be imported.

## Edit Menu

The Edit Menu provides standard edit commands (Undo, Redo, Cut, Copy, Paste and Delete) plus many other commands specific to editing audio or labels

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Undo: | Undo | none | Undoes the most recent editing action.
Redo: | Redo | none | Redoes the most recently undone editing action.
Cut: | Cut | none | Removes the selected audio data and/or labels and places these on the Audacity clipboard. By default, any audio or labels to right of the selection are shifted to the left.
Delete: | Delete | none | Removes the selected audio data and/or labels without copying these to the Audacity clipboard. By default, any audio or labels to right of the selection are shifted to the left.
Copy: | Copy | none | Copies the selected audio data to the Audacity clipboard without removing it from the project.
Paste: | Paste | none | Inserts whatever is on the Audacity clipboard at the position of the selection cursor in the project, replacing whatever audio data is currently selected, if any.
Duplicate: | Duplicate | none | Creates a new track containing only the current selection as a new clip.
EditMetaData: | Metadata... | none | The Metadata Editor modifies information about a track, such as the artist and genre. Typically used with MP3 files.
Preferences: | Preferences... | none | Preferences let you change most of the default behaviors and settings of Audacity. On Mac, Preferences are in the Audacity Menu and the default shortcut is ⌘ + ,.

### Edit: Remove Special

For more "advanced" removal of audio

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SplitCut: | Split Cut | none | Same as Cut, but none of the audio data or labels to right of the selection are shifted.
SplitDelete: | Split Delete | none | Same as Delete, but none of the audio data or labels to right of the selection are shifted.
Silence: | Silence Audio | none | Replaces the currently selected audio with absolute silence. Does not affect label tracks.
Trim: | Trim Audio | none | Deletes all audio but the selection. If there are other separate clips in the same track these are not removed or shifted unless trimming the entire length of a clip or clips. Does not affect label tracks.

### Edit: Clip Boundaries

Create or remove separate clips in the audio track. A clip inside an audio track is a separate section of that track which has been split so that it can be manipulated somewhat independently of the other clips in the track.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Split: | Split | none | Splits the current clip into two clips at the cursor point, or into three clips at the selection boundaries.
SplitNew: | Split New | none | Does a Split Cut on the current selection in the current track, then creates a new track and pastes the selection into the new track.
Join: | Join | none | If you select an area that overlaps one or more clips, they are all joined into one large clip. Regions in-between clips become silence.
Disjoin: | Detach at Silences | none | In a selection region that includes absolute silences, creates individual non-silent clips between the regions of silence. The silence becomes blank space between the clips.

### Edit: Labels

These commands are to add and edit labels.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
EditLabels: | Edit Labels... | none | Brings up a dialog box showing all of your labels in a keyboard-accessible tabular view. Handy buttons in the dialog let you insert or delete a label, or import and export labels to a file. See Labels Editor for more details.
AddLabel: | Add Label at Selection | none | Creates a new, empty label at the cursor or at the selection region.
AddLabelPlaying: | Add Label at Playback Position | none | Creates a new, empty label at the current playback or recording position.
PasteNewLabel: | Paste Text to New Label | none | Pastes the text on the Audacity clipboard at the cursor position in the currently selected label track. If there is no selection in the label track a point label is created. If a region is selected in the label track a region label is created. If no label track is selected one is created, and a new label is created.
TypeToCreateLabel: | Type to Create a Label (on/off) | none | When a label track has the yellow focus border, if this option is on, just type to create a label. Otherwise you must create a label first.

### Edit: Labeled Audio

Labeled Audio commands apply standard Edit Menu commands to the audio of one or more regions that are labeled. The labels themselves are not affected.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
CutLabels: | Cut | none | Same as the Cut command, but operates on labeled audio regions.
DeleteLabels: | Delete | none | Same as the Delete command, but operates on labeled audio regions.
SplitCutLabels: | Split Cut | none | Same as the Split Cut command, but operates on labeled audio regions.
SplitDeleteLabels: | Split Delete | none | Same as the Split Delete command, but operates on labeled audio regions.
SilenceLabels: | Silence Audio | none | Same as the Silence Audio command, but operates on labeled audio regions.
CopyLabels: | Copy | none | Same as the Copy command, but operates on labeled audio regions.
SplitLabels: | Split | none | Same as the Split command, but operates on labeled audio regions or points.
JoinLabels: | Join | none | Same as the Join command, but operates on labeled audio regions or points. You may need to select the audio and use Edit > Clip Boundaries > Join, to join all regions or points.
DisjoinLabels: | Detach at Silences | none | Same as the Detach at Silences command, but operates on labeled audio regions.

## Select Menu

Select Menu has commands that enable you make selections of tracks or parts of the tracks in your project.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SelectAll: | All | none | Selects all of the audio in all of the tracks.
SelectNone: | None | none | Deselects all of the audio in all of the tracks.
SelCursorStoredCursor: | Cursor to Stored Cursor Position | none | Selects from the position of the cursor to the previously stored cursor position
StoreCursorPosition: | Store Cursor Position | none | Stores the current cursor position for use in a later selection
ZeroCross: | At Zero Crossings | none | Moves the edges of a selection region (or the cursor position) slightly so they are at a rising zero crossing point.

### Select: Tracks

Tracks

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SelAllTracks: | In All Tracks | none | Extends the current selection up and/or down into all tracks in the project.
SelSyncLockTracks: | In All Sync-Locked Tracks | none | Extends the current selection up and/or down into all sync-locked tracks in the currently selected track group.

### Select: Region

For modifying, saving and restoring a selection.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

SetLeftSelection:

Left at Playback Position

none

When Audacity is playing, recording or paused, sets the left boundary of a potential selection by moving the cursor to the current position of the green playback cursor (or red recording cursor).

Otherwise, opens the "Set Left Selection Boundary" dialog for adjusting the time position of the left-hand selection boundary. If there is no selection, moving the time digits backwards creates a selection ending at the former cursor position, and moving the time digits forwards provides a way to move the cursor forwards to an exact point.

SetRightSelection:

Right at Playback Position

none

When Audacity is playing, recording or paused, sets the right boundary of the selection, thus drawing the selection from the cursor position to the current position of the green playback cursor (or red recording cursor).

Otherwise, opens the "Set Right Selection Boundary" dialog for adjusting the time position of the right-hand selection boundary. If there is no selection, moving the time digits forwards creates a selection starting at the former cursor position, and moving the time digits backwards provides a way to move the cursor backwards to an exact point.

SelTrackStartToCursor: | Track Start to Cursor | none | Selects a region in the selected track(s) from the start of the track to the cursor position.
SelCursorToTrackEnd: | Cursor to Track End | none | Selects a region in the selected track(s) from the cursor position to the end of the track.
SelTrackStartToEnd: | Track Start to End | none | Selects a region in the selected track(s) from the start of the track to the end of the track.
SelSave: | Store Selection | none | Stores the end points of a selection for later reuse.
SelRestore: | Retrieve Selection | none | Retrieves the end points of a previously stored selection.

### Select: Spectral

For making a selection of a frequency range.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
ToggleSpectralSelection: | Toggle Spectral Selection | none | Changes between selecting a time range and selecting the last selected spectral selection in that time range. This command toggles the spectral selection even if not in Spectrogram view, but you must be in Spectrogram view to use the spectral selection in one of the Spectral edit effects.
NextHigherPeakFrequency: | Next Higher Peak Frequency | none | When in Spectrogram view, snaps the center frequency to the next higher frequency peak, moving the spectral selection upwards.
NextLowerPeakFrequency: | Next Lower Peak Frequency | none | When in Spectrogram views snaps the center frequency to the next lower frequency peak, moving the spectral selection downwards.

### Select: Clip Boundaries

For modifying a selection, taking account of clips.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SelPrevClipBoundaryToCursor: | Previous Clip Boundary to Cursor | none | Selects from the current cursor position back to the right-hand edge of the previous clip.
SelCursorToNextClipBoundary: | Cursor to Next Clip Boundary | none | Selects from the current cursor position forward to the left-hand edge of the next clip.
SelPrevClip: | Previous Clip | none | Moves the selection to the previous clip.
SelNextClip: | Next Clip | none | Moves the selection to the next clip.

## View Menu

View Menu has commands that determine the amount of detail you see in all the tracks in the project window. It also lets you show or hide Toolbars and some additional windows such as Undo History.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
UndoHistory: | History... | none | Brings up the History window which can then be left open while using Audacity normally. History lists all undoable actions performed in the current project, including importing.
Karaoke: | Karaoke... | none | Brings up the Karaoke window, which displays the labels in a "bouncing ball" scrolling display
MixerBoard: | Mixer Board... | none | Mixer Board is an alternative view to the audio tracks in the main tracks window. Analogous to a hardware mixer board, each audio track is displayed in a Track Strip.
ShowExtraMenus: | Extra Menus (on/off) | none | Shows extra menus with many extra less-used commands.
ShowClipping: | Show Clipping (on/off) | none | Option to show or not show audio that is too loud (in red) on the wave form.

### View: Zoom

Zoom in/out on the horizontal axis. Show more detail or show a longer length of time.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
ZoomIn: | Zoom In | none | Zooms in on the horizontal axis of the audio displaying more detail over a shorter length of time.
ZoomNormal: | Zoom Normal | none | Zooms to the default view which displays about one inch per second.
ZoomOut: | Zoom Out | none | Zooms out displaying less detail over a greater length of time.
ZoomSel: | Zoom to Selection | none | Zooms in or out so that the selected audio fills the width of the window.
ZoomToggle: | Zoom Toggle | none | Changes the zoom back and forth between two preset levels.
AdvancedVZoom: | Advanced Vertical Zooming | none | Enable for left-click gestures in the vertical scale to control zooming.

### View: Track Size

Controls the sizes of tracks.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
FitInWindow: | Fit to Width | none | Zooms out until the entire project just fits in the window.
FitV: | Fit to Height | none | Adjusts the height of all the tracks until they fit in the project window.
CollapseAllTracks: | Collapse All Tracks | none | Collapses all tracks to take up the minimum amount of space.
ExpandAllTracks: | Expand Collapsed Tracks | none | Expands all collapsed tracks to their original size before the last collapse.

### View: Skip to

Move forward/backwards through the audio

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SkipSelStart: | Selection Start | none | When there is a selection, moves the cursor to the start of the selection and removes the selection.
SkipSelEnd: | Selection End | none | When there is a selection, moves the cursor to the end of the selection and removes the selection.

### View: Toolbars

Toolbars can be used to determine which of the Audacity toolbars are displayed. By default all toolbars are shown except Spectral Selection and Scrub

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
ResetToolbars: | Reset Toolbars | none | Using this command positions all toolbars in default location and size as they were when Audacity was first installed
ShowTransportTB: | Transport Toolbar | none | Controls playback and recording and skips to start or end of project when neither playing or recording
ShowToolsTB: | Tools Toolbar | none | Chooses various tools for selection, volume adjustment, zooming and time-shifting of audio
ShowRecordMeterTB: | Recording Meter Toolbar | none | Displays recording levels and toggles input monitoring when not recording
ShowPlayMeterTB: | Playback Meter Toolbar | none | Displays playback levels
ShowMixerTB: | Mixer Toolbar | none | Adjusts the recording and playback volumes of the devices currently selected in Device Toolbar
ShowEditTB: | Edit Toolbar | none | Cut, copy, paste, trim audio, silence audio, undo, redo, zoom tools
ShowTranscriptionTB: | Play-at-Speed Toolbar | none | Plays audio at a slower or faster speed than normal, affecting pitch
ShowScrubbingTB: | Scrub Toolbar | none | Controls playback and recording and skips to start or end of project when neither playing or recording
ShowDeviceTB: | Device Toolbar | none | Selects audio host, recording device, number of recording channels and playback device
ShowSelectionTB: | Selection Toolbar | none | Controls the sample rate of the project, snapping to the selection format and adjusts cursor and region position by keyboard input
ShowSpectralSelectionTB: | Spectral Selection Toolbar | none | Displays and lets you adjust the current spectral (frequency) selection without having to be in Spectrogram view

## Transport Menu

Transport Menu commands let you play or stop, loop play, scrub play or record (including timed and sound activated recordings).

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
RescanDevices: | Rescan Audio Devices | none | Rescan for audio devices connected to your computer, and update the playback and recording dropdown menus in Device Toolbar

### Transport: Playing

These commands control playback in Audacity. You can Start, Stop or Pause playback of the audio in your project.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
PlayStop: | Play/Stop | none | Starts and stops playback or stops a recording (stopping does not change the restart position). Therefore using any play or record command after stopping with "Play/Stop" will start playback or recording from the same Timeline position it last started from. You can also assign separate shortcuts for Play and Stop.
PlayStopSelect: | Play/Stop and Set Cursor | none | Starts playback like "Play/Stop", but stopping playback sets the restart position to the stop point. When stopped, this command is the same as "Play/Stop". When playing, this command stops playback and moves the cursor (or the start of the selection) to the position where playback stopped.
PlayLooped: | Loop Play | none | Plays the selection over and over again.
Pause: | Pause | none | Temporarily pauses playing or recording without losing your place.

### Transport: Recording

These commands control recording in Audacity. You can Start, Stop or Pause recording in your project. You can either start a recording on your existing track or an a new track.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Record1stChoice: | Record | none | Starts recording at the end of the currently selected track(s).
Record2ndChoice: | Record New Track | none | Recording begins on a new track at either the current cursor location or at the beginning of the current selection.
TimerRecord: | Timer Record... | none | Brings up the Timer Record dialog.
PunchAndRoll: | Punch and Roll Record | none | Re-record over audio, with a pre-roll of audio that comes before.
Pause: | Pause | none | Temporarily pauses playing or recording without losing your place.

### Transport: Scrubbing

Scrubbing is the action of moving the mouse pointer right or left so as to adjust the position, speed or direction of playback, listening to the audio at the same time - a convenient way to quickly navigate the waveform to find a particular event of interest. Speed changes are made by rotating the mouse wheel while scrubbing.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Scrub: | Scrub | none | Scrubbing is the action of moving the mouse pointer right or left so as to adjust the position, speed or direction of playback, listening to the audio at the same time.
Seek: | Seek | none | Seeking is similar to Scrubbing except that it is playback with skips, similar to using the seek button on a CD player.
ToggleScrubRuler: | Scrub Ruler | none | Shows (or hides) the scrub ruler, which is just below the timeline.

### Transport: Cursor to

These commands let you move the cursor to the start or end of the selection, track or any adjacent Clip that you may have

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
CursSelStart: | Selection Start | none | Moves the left edge of the current selection to the center of the screen, without changing the zoom level.
CursSelEnd: | Selection End | none | Moves the right edge of the current selection to the center of the screen, without changing the zoom level.
CursTrackStart: | Track Start | none | Moves the cursor to the start of the selected track.
CursTrackEnd: | Track End | none | Moves the cursor to the end of the selected track.
CursPrevClipBoundary: | Previous Clip Boundary | none | Moves the cursor position back to the right-hand edge of the previous clip
CursNextClipBoundary: | Next Clip Boundary | none | Moves the cursor position forward to the left-hand edge of the next clip
CursProjectStart: | Project Start | none | Moves the cursor to the beginning of the project.
CursProjectEnd: | Project End | none | Moves the cursor to the end of the project.

### Transport: Play Region

These commands enable you to lock a play region and unlock it

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
LockPlayRegion: | Lock | none | Locks standard playback to the current position of the playback region, or to the current position of the Quick-Play region).
UnlockPlayRegion: | Unlock | none | Removes the Play Region Lock.

### Transport: Transport Options

This submenu lets you manage and set various options for transport (playing and recording) in Audacity

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SoundActivationLevel: | Sound Activation Level... | none | Sets the activation level above which Sound Activated Recording will record.
SoundActivation: | Sound Activated Recording (on/off) | none | Toggles on and off the Sound Activated Recording option.
PinnedHead: | Pinned Play/Record Head (on/off) | none | You can change Audacity to play and record with a fixed head pinned to the Timeline. You can adjust the position of the fixed head by dragging it
Overdub: | Overdub (on/off) | none | Toggles on and off the Overdub option.
SWPlaythrough: | Software Playthrough (on/off) | none | Toggles on and off the Software Playthrough option.

## Tracks Menu

Tracks Menu provides commands for creating and removing tracks, applying operations to selected tracks such as mixing, resampling or converting from stereo to mono, and lets you add or edit labels.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Resample: | Resample... | none | Allows you to resample the selected track(s) to a new sample rate for use in the project
RemoveTracks: | Remove Tracks | none | Removes the selected track(s) from the project. Even if only part of a track is selected, the entire track is removed.
SyncLock: | Sync-Lock Tracks (on/off) | none | Ensures that length changes occurring anywhere in a defined group of tracks also take place in all audio or label tracks in that group.

### Tracks: Add New

Adds a new track

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
NewMonoTrack: | Mono Track | none | Creates a new empty mono audio track.
NewStereoTrack: | Stereo Track | none | Adds an empty stero track to the project
NewLabelTrack: | Label Track | none | Adds an empty label track to the project
NewTimeTrack: | Time Track | none | Adds an empty time track to the project. Time tracks are used to speed up and slow down audio.

### Tracks: Mix

Mixes down selected tracks to mono or stereo tracks

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Stereo to Mono: | Mix Stereo Down to Mono | none | Converts the selected stereo track(s) into the same number of mono tracks, combining left and right channels equally by averaging the volume of both channels.
MixAndRender: | Mix and Render | none | Mixes down all selected tracks to a single mono or stereo track, rendering to the waveform all real-time transformations that had been applied (such as track gain, panning, amplitude envelopes or a change in project rate).
MixAndRenderToNewTrack: | Mix and Render to New Track | none | Same as Tracks > Mix and Render except that the original tracks are preserved rather than being replaced by the resulting "Mix" track.

### Tracks: Mute/Unmute

Mutes or unmutes audio tracks in the project

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
MuteAllTracks: | Mute All Tracks | none | Mutes all the audio tracks in the project as if you had used the mute buttons from the Track Control Panel on each track.
UnmuteAllTracks: | Unmute All Tracks | none | Unmutes all the audio tracks in the project as if you had released the mute buttons from the Track Control Panel on each track.
MuteTracks: | Mute Tracks | none | Mutes the selected tracks.
UnmuteTracks: | Unmute Tracks | none | Unmutes the selected tracks.

### Tracks: Pan

Pans left right or center audio tracks in the project

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
PanLeft: | Left | none | Pan selected audio to left speaker
PanRight: | Right | none | Pan selected audio centrally.
PanCenter: | Center | none | Pan selected audio to right speaker.

### Tracks: Align Tracks

Commands that provide an automatic way of aligning selected tracks with the cursor, the selection, or with the start of the project.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Align_EndToEnd: | Align End to End | none | Aligns the selected tracks one after the other, based on their top-to-bottom order in the project window.
Align_Together: | Align Together | none | Align the selected tracks so that they start at the same (averaged) start time.
Align_StartToZero: | Start to Zero | none | Aligns the start of selected tracks with the start of the project.
Align_StartToSelStart: | Start to Cursor/Selection Start | none | Aligns the start of selected tracks with the current cursor position or with the start of the current selection.
Align_StartToSelEnd: | Start to Selection End | none | Aligns the start of selected tracks with the end of the current selection.
Align_EndToSelStart: | End to Cursor/Selection Start | none | Aligns the end of selected tracks with the current cursor position or with the start of the current selection.
Align_EndToSelEnd: | End to Selection End | none | Aligns the end of selected tracks with the end of the current selection.
MoveSelectionWithTracks: | Move Selection with Tracks (on/off) | none | Toggles on/off the selection moving with the realigned tracks, or staying put.

### Tracks: Sort Tracks

Sorts all tracks in the project from top to bottom in the project window, by Start Time or by Name.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SortByTime: | By Start Time | none | Sort tracks in order of start time.
SortByName: | By Name | none | Sort tracks in order by name.

## Generate Menu

Generate Menu lets you create audio containing tones, noise or silence.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

ManageGenerators:

Add / Remove Plug-ins...

none

Selecting this option from the Effect Menu (or the Generate Menu or Analyze Menu) takes you to a dialog where you can enable or disable particular Effects, Generators and Analyzers in Audacity. Even if you do not add any third-party plug-ins, you can use this to make the Effect menu shorter or longer as required. For details see Add / Remove Effects, Generators and Analyzers.

Built-in: | Built-in | none | Shows the list of available Audacity built-in effects but only if the user has effects "Grouped by Type" in Effects Preferences.
Nyquist: | Nyquist | none | Shows the list of available Nyquist effects but only if the user has effects "Grouped by Type" in Effects Preferences.

### Generate: Built-in

Shows the list of available Audacity built-in effects but only if the user has effects "Grouped by Type" in Effects Preferences.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

Chirp:

Chirp...

double StartFreq, (default:440)

double EndFreq, (default:1320)
double StartAmp, (default:0.8)
double EndAmp, (default:0.1)
enum Waveform, (default:Sine)

- Sine
- Square
- Sawtooth
- Square, no alias

enum Interpolation, (default:Linear)

- Linear
- Logarithmic

Generates four different types of tone waveforms like the Tone Generator, but additionally allows setting of the starting and ending amplitude and frequency.

DtmfTones: | DTMF Tones... | string Sequence, (default:audacity) double Duty Cycle, (default:55) double Amplitude, (default:0.8) | Generates dual-tone multi-frequency (DTMF) tones like those produced by the keypad on telephones.

Noise:

Noise...

enum Type, (default:White)

- White
- Pink
- Brownian

double Amplitude, (default:0.8)

Generates 'white', 'pink' or 'brown' noise.

Tone:

Tone...

double Frequency, (default:440)

double Amplitude, (default:0.8)
enum Waveform, (default:Sine)

- Sine
- Square
- Sawtooth
- Square, no alias

enum Interpolation, (default:Linear)

- Linear
- Logarithmic

Generates one of four different tone waveforms: Sine, Square, Sawtooth or Square (no alias), and a frequency between 1 Hz and half the current project rate.

### Generate: Nyquist

Shows the list of available Nyquist effects but only if the user has effects "Grouped by Type" in Effects Preferences.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

Pluck:

Pluck...

int pitch, (default:0)

enum fade, (default:Abrupt)

- Abrupt
- Gradual

double dur, (default:0)

A synthesized pluck tone with abrupt or gradual fade-out, and selectable pitch corresponding to a MIDI note.

RhythmTrack:

Rhythm Track...

double tempo, (default:0)

int timesig, (default:0)
double swing, (default:0)
int bars, (default:0)
double click-track-dur, (default:0)
double offset, (default:0)
enum click-type, (default:Metronome)

- Metronome
- Ping (short)
- Ping (long)
- Cowbell
- ResonantNoise
- NoiseClick
- Drip (short)
- Drip (long)

int high, (default:0)
int low, (default:0)

Generates a track with regularly spaced sounds at a specified tempo and number of beats per measure (bar).

RissetDrum: | Risset Drum... | double freq, (default:0) double decay, (default:0) double cf, (default:0) double bw, (default:0) double noise, (default:0) double gain, (default:0) | Produces a realistic drum sound.

## Effect Menu

Audacity includes many built-in effects and also lets you use a wide range of plug-in effects.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

ManageEffects:

Add / Remove Plug-ins...

none

Selecting this option from the Effect Menu (or the Generate Menu or Analyze Menu) takes you to a dialog where you can enable or disable particular Effects, Generators and Analyzers in Audacity. Even if you do not add any third-party plug-ins, you can use this to make the Effect menu shorter or longer as required. For details see Add / Remove Effects, Generators and Analyzers.

RepeatLastEffect: | Repeat Last Effect | none | Repeats the last used effect at its last used settings and without displaying any dialog.
LADSPA: | LADSPA | none | Shows the list of available LADSPA effects but only if the user has effects "Grouped by Type" in Effects Preferences.

### Effect: Built-in

No special notes for Built-in

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Amplify: | Amplify... | float Ratio, (default:0.9) bool AllowClipping, (default:False) | Increases or decreases the volume of the audio you have selected.

AutoDuck:

Auto Duck...

double DuckAmountDb, (default:-12)

double InnerFadeDownLen, (default:0)
double InnerFadeUpLen, (default:0)
double OuterFadeDownLen, (default:0.5)
double OuterFadeUpLen, (default:0.5)
double ThresholdDb, (default:-30)
double MaximumPause, (default:1)

Reduces (ducks) the volume of one or more tracks whenever the volume of a specified "control" track reaches a particular level. Typically used to make a music track softer whenever speech in a commentary track is heard.

BassAndTreble: | Bass and Treble... | double Bass, (default:0) double Treble, (default:0) double Gain, (default:0) bool Link Sliders, (default:False) | Increases or decreases the lower frequencies and higher frequencies of your audio independently; behaves just like the bass and treble controls on a stereo system.
ChangePitch: | Change Pitch... | double Percentage, (default:0) bool SBSMS, (default:False) | Change the pitch of a selection without changing its tempo.
ChangeSpeed: | Change Speed... | double Percentage, (default:0) | Change the speed of a selection, also changing its pitch.
ChangeTempo: | Change Tempo... | double Percentage, (default:0) bool SBSMS, (default:False) | Change the tempo and length (duration) of a selection without changing its pitch.
ClickRemoval: | Click Removal... | int Threshold, (default:200) int Width, (default:20) | Click Removal is designed to remove clicks on audio tracks and is especially suited to declicking recordings made from vinyl records.

Compressor:

Compressor...

double Threshold, (default:-12)

double NoiseFloor, (default:-40)
double Ratio, (default:2)
double AttackTime, (default:0.2)
double ReleaseTime, (default:1)
bool Normalize, (default:True)
bool UsePeak, (default:False)

Compresses the dynamic range by two alternative methods. The default "RMS" method makes the louder parts softer, but leaves the quieter audio alone. The alternative "peaks" method makes the entire audio louder, but amplifies the louder parts less than the quieter parts. Make-up gain can be applied to either method, making the result as loud as possible without clipping, but not changing the dynamic range further.

Distortion:

Distortion...

enum Type, (default:Hard Clipping)

- Hard Clipping
- Soft Clipping
- Soft Overdrive
- Medium Overdrive
- Hard Overdrive
- Cubic Curve (odd harmonics)
- Even Harmonics
- Expand and Compress
- Leveller
- Rectifier Distortion
- Hard Limiter 1413

bool DC Block, (default:False)
double Threshold dB, (default:-6)
double Noise Floor, (default:-70)
double Parameter 1, (default:50)
double Parameter 2, (default:50)
int Repeats, (default:1)

Use the Distortion effect to make the audio sound distorted. By distorting the waveform the frequency content is changed, which will often make the sound "crunchy" or "abrasive". Technically this effect is a waveshaper. The result of waveshaping is equivalent to applying non-linear amplification to the audio waveform. Preset shaping functions are provided, each of which produces a different type of distortion.

Echo:

Echo...

float Delay, (default:1)

float Decay, (default:0.5)

Repeats the selected audio again and again, normally softer each time and normally not blended into the original sound until some time after it starts. The delay time between each repeat is fixed, with no pause in between each repeat. For a more configurable echo effect with a variable delay time and pitch-changed echoes, see Delay.

FadeIn: | Fade In | none | Applies a linear fade-in to the selected audio - the rapidity of the fade-in depends entirely on the length of the selection it is applied to. For a more customizable logarithmic fade, use the Envelope Tool on the Tools Toolbar.
FadeOut: | Fade Out | none | Applies a linear fade-out to the selected audio - the rapidity of the fade-out depends entirely on the length of the selection it is applied to. For a more customizable logarithmic fade, use the Envelope Tool on the Tools Toolbar.

FilterCurve:

Filter Curve...

size_t FilterLength, (default:8191)

bool InterpolateLin, (default:False)
enum InterpolationMethod, (default:B-spline)

- B-spline
- Cosine
- Cubic

double f0, (default:0)
double v0, (default:0)

Adjusts the volume levels of particular frequencies

GraphicEq:

Graphic EQ...

size_t FilterLength, (default:8191)

bool InterpolateLin, (default:False)
enum InterpolationMethod, (default:B-spline)

- B-spline
- Cosine
- Cubic

double f0, (default:0)
double v0, (default:0)

Adjusts the volume levels of particular frequencies

Invert: | Invert | none | This effect flips the audio samples upside-down. This normally does not affect the sound of the audio at all. It is occasionally useful for vocal removal.
LoudnessNormalization: | Loudness Normalization... | bool StereoIndependent, (default:False) double LUFSLevel, (default:-23) double RMSLevel, (default:-20) bool DualMono, (default:True) int NormalizeTo, (default:0) | Changes the perceived loudness of the audio.
NoiseReduction: | Noise Reduction... | none | This effect is ideal for reducing constant background noise such as fans, tape noise, or hums. It will not work very well for removing talking or music in the background. More details here This effect is not currently available from scripting.
Normalize: | Normalize... | double PeakLevel, (default:-1) bool ApplyGain, (default:True) bool RemoveDcOffset, (default:True) bool StereoIndependent, (default:False) | Use the Normalize effect to set the maximum amplitude of a track, equalize the amplitudes of the left and right channels of a stereo track and optionally remove any DC offset from the track

Paulstretch:

Paulstretch...

float Stretch Factor, (default:10)

float Time Resolution, (default:0.25)

Use Paulstretch only for an extreme time-stretch or "stasis" effect, This may be useful for synthesizer pad sounds, identifying performance glitches or just creating interesting aural textures. Use Change Tempo or Sliding Time Scale rather than Paulstretch for tasks like slowing down a song to a "practice" tempo.

Phaser:

Phaser...

int Stages, (default:2)

int DryWet, (default:128)
double Freq, (default:0.4)
double Phase, (default:0)
int Depth, (default:100)
int Feedback, (default:0)
double Gain, (default:-6)

The name "Phaser" comes from "Phase Shifter", because it works by combining phase-shifted signals with the original signal. The movement of the phase-shifted signals is controlled using a Low Frequency Oscillator (LFO).

Repair: | Repair | none | Fix one particular short click, pop or other glitch no more than 128 samples long.
Repeat: | Repeat... | int Count, (default:1) | Repeats the selection the specified number of times.

Reverb:

Reverb...

double RoomSize, (default:75)

double Delay, (default:10)
double Reverberance, (default:50)
double HfDamping, (default:50)
double ToneLow, (default:100)
double ToneHigh, (default:100)
double WetGain, (default:-1)
double DryGain, (default:-1)
double StereoWidth, (default:100)
bool WetOnly, (default:False)

A configurable stereo reverberation effect with built-in and user-added presets. It can be used to add ambience (an impression of the space in which a sound occurs) to a mono sound. Also use it to increase reverberation in stereo audio that sounds too "dry" or "close".

Reverse: | Reverse | none | Reverses the selected audio; after the effect the end of the audio will be heard first and the beginning last.

SlidingStretch:

Sliding Stretch...

double RatePercentChangeStart, (default:0)

double RatePercentChangeEnd, (default:0)
double PitchHalfStepsStart, (default:0)
double PitchHalfStepsEnd, (default:0)
double PitchPercentChangeStart, (default:0)
double PitchPercentChangeEnd, (default:0)

This effect allows you to make a continuous change to the tempo and/or pitch of a selection by choosing initial and/or final change values.

TruncateSilence:

Truncate Silence...

double Threshold, (default:-20)

enum Action, (default:Truncate Detected Silence)

- Truncate Detected Silence
- Compress Excess Silence

double Minimum, (default:0.5)
double Truncate, (default:0.5)
double Compress, (default:50)
bool Independent, (default:False)

Automatically try to find and eliminate audible silences. Do not use this with faded audio.

Wahwah: | Wahwah... | double Freq, (default:1.5) double Phase, (default:0) int Depth, (default:70) double Resonance, (default:2.5) int Offset, (default:30) double Gain, (default:-6) | Rapid tone quality variations, like that guitar sound so popular in the 1970's.

### Effect: Nyquist

No special notes for Nyquist

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

AdjustableFade:

Adjustable Fade...

enum type, (default:Up)

- Up
- Down
- SCurveUp
- SCurveDown

double curve, (default:0)
enum units, (default:Percent)

- Percent
- dB

double gain0, (default:0)
double gain1, (default:0)
enum preset, (default:None)

- None
- LinearIn
- LinearOut
- ExponentialIn
- ExponentialOut
- LogarithmicIn
- LogarithmicOut
- RoundedIn
- RoundedOut
- CosineIn
- CosineOut
- SCurveIn
- SCurveOut

enables you to control the shape of the fade (non-linear fading) to be applied by adjusting various parameters; allows partial (that is not from or to zero) fades up or down.

ClipFix: | Clip Fix... | double threshold, (default:0) double gain, (default:0) | Clip Fix attempts to reconstruct clipped regions by interpolating the lost signal.
CrossfadeClips: | Crossfade Clips |  | Use Crossfade Clips to apply a simple crossfade to a selected pair of clips in a single audio track.

CrossfadeTracks:

Crossfade Tracks...

enum type, (default:ConstantGain)

- ConstantGain
- ConstantPower1
- ConstantPower2
- CustomCurve

double curve, (default:0)
enum direction, (default:Automatic)

- Automatic
- OutIn
- InOut

Use Crossfade Tracks to make a smooth transition between two overlapping tracks one above the other. Place the track to be faded out above the track to be faded in then select the overlapping region in both tracks and apply the effect.

Delay:

Delay...

enum delay-type, (default:Regular)

- Regular
- BouncingBall
- ReverseBouncingBall

double dgain, (default:0)
double delay, (default:0)
enum pitch-type, (default:PitchTempo)

- PitchTempo
- LQPitchShift

double shift, (default:0)
int number, (default:0)
enum constrain, (default:Yes)

- Yes
- No

A configurable delay effect with variable delay time and pitch shifting of the delays.

High-passFilter:

High-Pass Filter...

double frequency, (default:0)

enum rolloff, (default:dB6)

- dB6
- dB12
- dB24
- dB36
- dB48

Passes frequencies above its cutoff frequency and attenuates frequencies below its cutoff frequency.

Limiter:

Limiter...

enum type, (default:SoftLimit)

- SoftLimit
- HardLimit
- SoftClip
- HardClip

double gain-L, (default:0)
double gain-R, (default:0)
double thresh, (default:0)
double hold, (default:0)
enum makeup, (default:No)

- No
- Yes

Limiter passes signals below a specified input level unaffected or gently reduced, while preventing the peaks of stronger signals from exceeding this threshold. Mastering engineers often use this type of dynamic range compression combined with make-up gain to increase the perceived loudness of an audio recording during the audio mastering process.

Low-passFilter:

Low-Pass Filter...

double frequency, (default:0)

enum rolloff, (default:dB6)

- dB6
- dB12
- dB24
- dB36
- dB48

Passes frequencies below its cutoff frequency and attenuates frequencies above its cutoff frequency.

NotchFilter: | Notch Filter... | double frequency, (default:0) double q, (default:0) | Greatly attenuate ("notch out"), a narrow frequency band. This is a good way to remove mains hum or a whistle confined to a specific frequency with minimal damage to the remainder of the audio.
SpectralEditMultiTool: | Spectral edit multi tool |  | When the selected track is in spectrogram or spectrogram log(f) view, applies a notch filter, high pass filter or low pass filter according to the spectral selection made. This effect can also be used to change the audio quality as an alternative to using Equalization.

SpectralEditParametricEq:

Spectral edit parametric EQ...

double control-gain, (default:0)

When the selected track is in spectrogram or spectrogram log(f) view and the spectral selection has a center frequency and an upper and lower boundary, performs the specified band cut or band boost. This can be used as an alternative to Equalization or may also be useful to repair damaged audio by reducing frequency spikes or boosting other frequencies to mask spikes.

SpectralEditShelves:

Spectral edit shelves...

double control-gain, (default:0)

When the selected track is in spectrogram or spectrogram log(f) view, applies either a low- or high-frequency shelving filter or both filters, according to the spectral selection made. This can be used as an alternative to Equalization or may also be useful to repair damaged audio by reducing frequency spikes or boosting other frequencies to mask spikes.

StudioFadeOut: | Studio Fade Out |  | Applies a more musical fade out to the selected audio, giving a more pleasing sounding result.

Tremolo:

Tremolo...

enum wave, (default:Sine)

- Sine
- Triangle
- Sawtooth
- InverseSawtooth
- Square

int phase, (default:0)
int wet, (default:0)
double lfo, (default:0)

Modulates the volume of the selection at the depth and rate selected in the dialog. The same as the tremolo effect familiar to guitar and keyboard players.

VocalReductionAndIsolation:

Vocal Reduction and Isolation...

enum action, (default:RemoveToMono)

- RemoveToMono
- Remove
- Isolate
- IsolateInvert
- RemoveCenterToMono
- RemoveCenter
- IsolateCenter
- IsolateCenterInvert
- Analyze

double strength, (default:0)
double low-transition, (default:0)
double high-transition, (default:0)

Attempts to remove or isolate center-panned audio from a stereo track. Most "Remove" options in this effect preserve the stereo image.

Vocoder:

Vocoder...

double dst, (default:0)

enum mst, (default:BothChannels)

- BothChannels
- RightOnly

int bands, (default:0)
double track-vl, (default:0)
double noise-vl, (default:0)
double radar-vl, (default:0)
double radar-f, (default:0)

Synthesizes audio (usually a voice) in the left channel of a stereo track with a carrier wave (typically white noise) in the right channel to produce a modified version of the left channel. Vocoding a normal voice with white noise will produce a robot-like voice for special effects.

## Analyze Menu

The Analyze Menu contains tools for finding out about the characteristics of your audio, or labeling key feature.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

ManageAnalyzers:

Add / Remove Plug-ins...

none

Selecting this option from the Effect Menu (or the Generate Menu or Analyze Menu) takes you to a dialog where you can enable or disable particular Effects, Generators and Analyzers in Audacity. Even if you do not add any third-party plug-ins, you can use this to make the Effect menu shorter or longer as required. For details see Add / Remove Effects, Generators and Analyzers.

ContrastAnalyser: | Contrast... | none | Analyzes a single mono or stereo speech track to determine the average RMS difference in volume (contrast) between foreground speech and background music, audience noise or similar. The purpose is to determine if the speech will be intelligible to the hard of hearing.
PlotSpectrum: | Plot Spectrum... | none | Takes the selected audio (which is a set of sound pressure values at points in time) and converts it to a graph of frequencies against amplitudes.
FindClipping: | Find Clipping... | int Duty Cycle Start, (default:3) int Duty Cycle End, (default:3) | Displays runs of clipped samples in a Label Track, as a screen-reader accessible alternative to View > Show Clipping. A run must include at least one clipped sample, but may include unclipped samples too.

### Analyze: Nyquist

No special notes for Nyquist

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
BeatFinder: | Beat Finder... | int thresval, (default:0) | Attempts to place labels at beats which are much louder than the surrounding audio. It's a fairly rough and ready tool, and will not necessarily work well on a typical modern pop music track with compressed dynamic range. If you do not get enough beats detected, try reducing the "Threshold Percentage" setting.

LabelSounds:

Label Sounds...

double threshold, (default:0)

enum measurement, (default:peak)

- peak
- avg
- rms

double sil-dur, (default:0)
double snd-dur, (default:0)
enum type, (default:before)

- before
- after
- around
- between

double pre-offset, (default:0)
double post-offset, (default:0)
string text, (default:"")

Divides up a track by placing labels for areas of sound that are separated by silence.

## Tools Menu

The Tools Menu contains customisable tools.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

ManageTools:

Add / Remove Plug-ins...

none

Selecting this option from the Effect Menu (or the Generate Menu or Analyze Menu) takes you to a dialog where you can enable or disable particular Effects, Generators and Analyzers in Audacity. Even if you do not add any third-party plug-ins, you can use this to make the Effect menu shorter or longer as required. For details see Add / Remove Effects, Generators and Analyzers.

ManageMacros: | Macros... | none | Creates a new macro or edits an existing macro.
Apply Macro: | Apply Macro | none | Displays a menu with list of all your Macros. Selecting any of these Macros by clicking on it will cause that Macro to be applied to the current project.

Screenshot:

Screenshot...

string Path, (default:)

enum CaptureWhat, (default:Window)

- Window
- FullWindow
- WindowPlus
- Fullscreen
- Toolbars
- Effects
- Scriptables
- Preferences
- Selectionbar
- SpectralSelection
- Timer
- Tools
- Transport
- Mixer
- Meter
- PlayMeter
- RecordMeter
- Edit
- Device
- Scrub
- Play-at-Speed
- Trackpanel
- Ruler
- Tracks
- FirstTrack
- FirstTwoTracks
- FirstThreeTracks
- FirstFourTracks
- SecondTrack
- TracksPlus
- FirstTrackPlus
- AllTracks
- AllTracksPlus

enum Background, (default:None)

- Blue
- White
- None

bool ToTop, (default:True)

A tool, mainly used in documentation, to capture screenshots of Audacity.

Benchmark: | Run Benchmark... | none | A tool for measuring the performance of one part of Audacity.
NyquistPrompt: | Nyquist Prompt... | string Command, (default:) int Version, (default:3) | Brings up a dialog where you can enter Nyquist commands. Nyquist is a programming language for generating, processing and analyzing audio. For more information see Nyquist Plug-ins Reference.

NyquistPlug-inInstaller:

Nyquist Plug-in Installer...

string files, (default:)

enum overwrite, (default:Disallow)

- Disallow
- Allow

A Nyquist plug-in that simplifies the installation of other Nyquist plug-ins.

RegularIntervalLabels:

Regular Interval Labels...

enum mode, (default:Both)

- Both
- Number
- Interval

int totalnum, (default:0)
double interval, (default:0)
double region, (default:0)
enum adjust, (default:No)

- No
- Yes

string labeltext, (default:)
enum zeros, (default:TextOnly)

- TextOnly
- OneBefore
- TwoBefore
- ThreeBefore
- OneAfter
- TwoAfter
- ThreeAfter

int firstnum, (default:0)
enum verbose, (default:Details)

- Details
- Warnings
- None

Places labels in a long track so as to divide it into smaller, equally sized segments.

SampleDataExport:

Sample Data Export...

int number, (default:0)

enum units, (default:dB)

- dB
- Linear

string filename, (default:)
enum fileformat, (default:None)

- None
- Count
- Time

enum header, (default:None)

- None
- Minimal
- Standard
- All

string optext, (default:)
enum channel-layout, (default:SameLine)

- SameLine
- Alternate
- LFirst

enum messages, (default:Yes)

- Yes
- Errors
- None

Reads the values of successive samples from the selected audio and prints this data to a plain text, CSV or HTML file.

SampleDataImport:

Sample Data Import...

string filename, (default:)

enum bad-data, (default:ThrowError)

- ThrowError
- ReadAsZero

Reads numeric values from a plain ASCII text file and creates a PCM sample for each numeric value read.

### Tools: Apply Macro

Displays a menu with list of all your Macros. Selecting any of these Macros by clicking on it will cause that Macro to be applied to the current project.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
ApplyMacrosPalette: | Palette... | none | Displays a menu with list of all your Macros which can be applied to the current project or to audio files..
Macro_FadeEnds: | Fade Ends | none | Fades in the first second and fades out the last second of a track.
Macro_MP3Conversion: | MP3 Conversion | none | Converts MP3.

## Extra Menu

The Extra menu provides access to additional Commands that are not available in the normal default Audacity menus.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
PlayAtSpeed: | Play-at-Speed | none | Extra commands related to play at speed
FullScreenOnOff: | Full Screen (on/off) | none | Toggle full screen mode with no title bar

### Extra: Transport

Extra commands related to play and record

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
Play: | Play | none | Play (or stop) audio
Stop: | Stop | none | Stop audio
PlayOneSec: | Play One Second | none | Plays for one second centered on the current mouse pointer position (not from the current cursor position). See this page for an example.
PlayToSelection: | Play to Selection | none | Plays to or from the current mouse pointer position to or from the start or end of the selection, depending on the pointer position. See this page for more details.
PlayBeforeSelectionStart: | Play Before Selection Start | none | Plays a short period before the start of the selected audio, the period before shares the setting of the cut preview.
PlayAfterSelectionStart: | Play After Selection Start | none | Plays a short period after the start of the selected audio, the period after shares the setting of the cut preview.
PlayBeforeSelectionEnd: | Play Before Selection End | none | Plays a short period before the end of the selected audio, the period before shares the setting of the cut preview.
PlayAfterSelectionEnd: | Play After Selection End | none | Plays a short period after the end of the selected audio, the period after shares the setting of the cut preview.
PlayBeforeAndAfterSelectionStart: | Play Before and After Selection Start | none | Plays a short period before and after the start of the selected audio, the periods before and after share the setting of the cut preview.
PlayBeforeAndAfterSelectionEnd: | Play Before and After Selection End | none | Plays a short period before and after the end of the selected audio, the periods before and after share the setting of the cut preview.
PlayCutPreview: | Play Cut Preview | none | Plays audio excluding the selection

### Extra: Tools

Extra commands to select the tool, for example time-shift, envelopes, multi-tool.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SelectTool: | Selection Tool | none | Chooses Selection tool.
EnvelopeTool: | Envelope Tool | none | Chooses Envelope tool.
DrawTool: | Draw Tool | none | Chooses Draw tool.
ZoomTool: | Zoom Tool | none | Chooses Zoom tool.
TimeShiftTool: | Time Shift Tool | none | Chooses Time Shift tool.
MultiTool: | Multi Tool | none | Chooses the Multi-Tool
PrevTool: | Previous Tool | none | Cycles backwards through the tools, starting from the currently selected tool: starting from Selection, it would navigate to Multi-tool to Time Shift to Zoom to Draw to Envelope to Selection.
NextTool: | Next Tool | none | Cycles forwards through the tools, starting from the currently selected tool: starting from Selection, it would navigate to Envelope to Draw to Zoom to Time Shift to Multi-tool to Selection.

### Extra: Mixer

Extra commands related to volume

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
OutputGain: | Adjust Playback Volume... | none | Displays the Playback Volume dialog. You can type a new value for the playback volume (between 0 and 1), or press Tab, then use the left and right arrow keys to adjust the slider.
OutputGainInc: | Increase Playback Volume | none | Each key press will increase the playback volume by 0.1.
OutputGainDec: | Decrease Playback Volume | none | Each key press will decrease the playback volume by 0.1.
InputGain: | Adjust Recording Volume... | none | Displays the Recording Volume dialog. You can type a new value for the recording volume (between 0 and 1), or press Tab, then use the left and right arrow keys to adjust the slider.
InputGainInc: | Increase Recording Volume | none | Each key press will increase the recording volume by 0.1.
InputGainDec: | Decrease Recording Volume | none | Each key press will decrease the recording volume by 0.1.

### Extra: Edit

Extra commands related to editing

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
DeleteKey: | Delete Key | none | Deletes the selection. When focus is in Selection Toolbar, BACKSPACE is not a shortcut but navigates back to the previous digit and sets it to zero.
DeleteKey2: | Delete Key2 | none | Deletes the selection.

### Extra: Play-at-Speed

Extra commands related to play at speed

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
PlayAtSpeed: | Normal Play-at-Speed | none | Play audio at a faster or slower speed
PlayAtSpeedLooped: | Loop Play-at-Speed | none | Combines looped play and play at speed
PlayAtSpeedCutPreview: | Play Cut Preview-at-Speed | none | Combines cut preview and play at speed
SetPlaySpeed: | Adjust Playback Speed... | none | Displays the Playback Speed dialog. You can type a new value for the playback volume (between 0 and 1), or press Tab, then use the left and right arrow keys to adjust the slider.
PlaySpeedInc: | Increase Playback Speed | none | Each key press will increase the playback speed by 0.1.
PlaySpeedDec: | Decrease Playback Speed | none | Each key press will decrease the playback speed by 0.1.
MoveToPrevLabel: | Move to Previous Label | none | Moves selection to the previous label
MoveToNextLabel: | Move to Next Label | none | Moves selection to the next label

### Extra: Seek

Extra commands related to seeking

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SeekLeftShort: | Short Seek Left During Playback | none | Skips the playback cursor back one second by default.
SeekRightShort: | Short Seek Right During Playback | none | Skips the playback cursor forward one second by default.
SeekLeftLong: | Long Seek Left During Playback | none | Skips the playback cursor back 15 seconds by default.
SeekRightLong: | Long Seek Right During Playback | none | Skips the playback cursor forward 15 seconds by default.

### Extra: Device

Extra commands related to selecting a device

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
InputDevice: | Change Recording Device... | none | Displays the Select recording Device dialog for choosing the recording device, but only if the "Recording Device" dropdown menu in Device Toolbar has entries for devices. Otherwise, an recording error message will be displayed.
OutputDevice: | Change Playback Device... | none | Displays the Select Playback Device dialog for choosing the playback device, but only if the "Playback Device" dropdown menu in Device Toolbar has entries for devices. Otherwise, an error message will be displayed.
AudioHost: | Change Audio Host... | none | Displays the Select Audio Host dialog for choosing the particular interface with which Audacity communicates with your chosen playback and recording devices.
InputChannels: | Change Recording Channels... | none | Displays the Select Recording Channels dialog for choosing the number of channels to be recorded by the chosen recording device.

### Extra: Selection

Extra commands related to selecting.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
SnapToOff: | Snap-To Off | none | Equivalent to setting the Snap To control in Selection Toolbar to "Off".
SnapToNearest: | Snap-To Nearest | none | Equivalent to setting the Snap To control in Selection Toolbar to "Nearest".
SnapToPrior: | Snap-To Prior | none | Equivalent to setting the Snap To control in Selection Toolbar to "Prior".
SelStart: | Selection to Start | none | Select from cursor to start of track
SelEnd: | Selection to End | none | Select from cursor to end of track
SelExtLeft: | Selection Extend Left | none | Increases the size of the selection by extending it to the left. The amount of increase is dependent on the zoom level. If there is no selection one is created starting at the cursor position.
SelExtRight: | Selection Extend Right | none | Increases the size of the selection by extending it to the right. The amount of increase is dependent on the zoom level. If there is no selection one is created starting at the cursor position.
SelSetExtLeft: | Set (or Extend) Left Selection | none | Extend selection left a little (is this a duplicate?)
SelSetExtRight: | Set (or Extend) Right Selection | none | Extend selection right a litlle (is this a duplicate?)
SelCntrLeft: | Selection Contract Left | none | Decreases the size of the selection by contracting it from the right. The amount of decrease is dependent on the zoom level. If there is no selection no action is taken.
SelCntrRight: | Selection Contract Right | none | Decreases the size of the selection by contracting it from the left. The amount of decrease is dependent on the zoom level. If there is no selection no action is taken.

### Extra: Focus

Extra commands to set focus, usually focus on one track

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
PrevFrame: | Move Backward from Toolbars to Tracks | none | Move backward through currently focused toolbar in Upper Toolbar dock area, Track View and currently focused toolbar in Lower Toolbar dock area. Each use moves the keyboard focus as indicated.
NextFrame: | Move Forward from Toolbars to Tracks | none | Move forward through currently focused toolbar in Upper Toolbar dock area, Track View and currently focused toolbar in Lower Toolbar dock area. Each use moves the keyboard focus as indicated.
PrevTrack: | Move Focus to Previous Track | none | Focus one track up
NextTrack: | Move Focus to Next Track | none | Focus one track down
FirstTrack: | Move Focus to First Track | none | Focus on first track
LastTrack: | Move Focus to Last Track | none | Focus on last track
ShiftUp: | Move Focus to Previous and Select | none | Focus one track up and select it
ShiftDown: | Move Focus to Next and Select | none | Focus one track down and select it
Toggle: | Toggle Focused Track | none | Toggle focus on current track
ToggleAlt: | Toggle Focused Track | none | Toggle focus on current track

### Extra: Cursor

Extra commands to move the cursor

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

CursorLeft:

Cursor Left

none

When not playing audio, moves the editing cursor one screen pixel to left. When a Snap To option is chosen, moves the cursor to the preceding unit of time as determined by the current selection format. If the key is held down, the cursor speed depends on the length of the tracks. When playing audio, moves the playback cursor as described at "Cursor Short Jump Left"

CursorRight:

Cursor Right

none

When not playing audio, moves the editing cursor one screen pixel to right. When a Snap To option is chosen, moves the cursor to the following unit of time as determined by the current selection format. If the key is held down, the cursor speed depends on the length of the tracks. When playing audio, moves the playback cursor as described at "Cursor Short Jump Right"

CursorShortJumpLeft: | Cursor Short Jump Left | none | When not playing audio, moves the editing cursor one second left by default. When playing audio, moves the playback cursor one second left by default. The default value can be changed by adjusting the "Short Period" under "Seek Time when playing" in Playback Preferences.
CursorShortJumpRight: | Cursor Short Jump Right | none | When not playing audio, moves the editing cursor one second right by default. When playing audio, moves the playback cursor one second right by default. The default value can be changed by adjusting the "Short Period" under "Seek Time when playing" in Playback Preferences.
CursorLongJumpLeft: | Cursor Long Jump Left | none | When not playing audio, moves the editing cursor 15 seconds left by default. When playing audio, moves the playback cursor 15 seconds left by default. The default value can be changed by adjusting the "Long Period" under "Seek Time when playing" in Playback Preferences.
CursorLongJumpRight: | Cursor Long Jump Right | none | When not playing audio, moves the editing cursor 15 seconds right by default. When playing audio, moves the playback cursor 15 seconds right by default. The default value can be changed by adjusting the "Long Period" under "Seek Time when playing" in Playback Preferences.
ClipLeft: | Clip Left | none | Moves the currently focused audio track (or a separate clip in that track which contains the editing cursor or selection region) one screen pixel to left.
ClipRight: | Clip Right | none | Moves the currently focused audio track (or a separate clip in that track which contains the editing cursor or selection region) one screen pixel to right.

### Extra: Track

Extra commands to operate on a track that has focus

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
TrackPan: | Change Pan on Focused Track... | none | Brings up the Pan dialog for the focused track where you can enter a pan value, or use the slider for finer control of panning than is available when using the track pan slider.
TrackPanLeft: | Pan Left on Focused Track | none | Controls the pan slider on the focused track. Each keypress changes the pan value by 10% left.
TrackPanRight: | Pan Right on Focused Track | none | Controls the pan slider on the focused track. Each keypress changes the pan value by 10% right.
TrackGain: | Change Gain on Focused Track... | none | Brings up the Gain dialog for the focused track where you can enter a gain value, or use the slider for finer control of gain than is available when using the track pan slider.
TrackGainInc: | Increase Gain on Focused Track | none | Controls the gain slider on the focused track. Each keypress increases the gain value by 1 dB.
TrackGainDec: | Decrease Gain on Focused Track | none | Controls the gain slider on the focused track. Each keypress decreases the gain value by 1 dB.
TrackMenu: | Open Menu on Focused Track... | none | Opens the Audio Track Dropdown Menu on the focused audio track or other track type. In the audio track dropdown, use Up, and Down, arrow keys to navigate the menu and Enter, to select a menu item. Use Right, arrow to open the "Set Sample Format" and "Set Rate" choices or Left, arrow to leave those choices.
TrackMute: | Mute/Unmute Focused Track | none | Toggles the Mute button on the focused track.
TrackSolo: | Solo/Unsolo Focused Track | none | Toggles the Solo button on the focused track.
TrackClose: | Close Focused Track | none | Close (remove) the focused track only.
TrackMoveUp: | Move Focused Track Up | none | Moves the focused track up by one track and moves the focus there.
TrackMoveDown: | Move Focused Track Down | none | Moves the focused track down by one track and moves the focus there.
TrackMoveTop: | Move Focused Track to Top | none | Moves the focused track up to the top of the track table and moves the focus there.
TrackMoveBottom: | Move Focused Track to Bottom | none | Moves the focused track down to the bottom of the track table and moves the focus there.

### Extra: Scriptables I

These commands were originally written for scripting Audacity, e.g via a Python script that uses mod-script-pipe. The commands though are also present in the menu, available from macros, and available from within Nyquist using (AUD-DO "command")

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

SelectTime:

Select Time...

double Start, (default:unchanged)

double End, (default:unchanged)
enum RelativeTo, (default:unchanged)

- ProjectStart
- Project
- ProjectEnd
- SelectionStart
- Selection
- SelectionEnd

Modifies the temporal selection. Start and End are time. FromEnd allows selection from the end, which is handy to fade in and fade out a track.

SelectFrequencies: | Select Frequencies... | double High, (default:unchanged) double Low, (default:unchanged) | Modifies what frequencies are selected. High and Low are for spectral selection.

SelectTracks:

Select Tracks...

double Track, (default:unchanged)

double TrackCount, (default:unchanged)
enum Mode, (default:unchanged)

- Set
- Add
- Remove

Modifies which tracks are selected. First and Last are track numbers. High and Low are for spectral selection. The Mode parameter allows complex selections, e.g adding or removing tracks from the current selection.

SetTrackStatus: | Set Track Status... | string Name, (default:unchanged) bool Selected, (default:unchanged) bool Focused, (default:unchanged) | Sets properties for a track or channel (or both).Name is used to set the name. It is not used in choosing the track.
SetTrackAudio: | Set Track Audio... | bool Mute, (default:unchanged) bool Solo, (default:unchanged) double Gain, (default:unchanged) double Pan, (default:unchanged) | Sets properties for a track or channel (or both). Can set pan, gain, mute and solo.

SetTrackVisuals:

Set Track Visuals...

int Height, (default:unchanged)

enum Display, (default:unchanged)

- Waveform
- Spectrogram

enum Scale, (default:unchanged)

- Linear
- dB

enum Color, (default:unchanged)

- Color0
- Color1
- Color2
- Color3

enum VZoom, (default:unchanged)

- Reset
- Times2
- HalfWave

double VZoomHigh, (default:unchanged)
double VZoomLow, (default:unchanged)
bool SpecPrefs, (default:unchanged)
bool SpectralSel, (default:unchanged)
enum Scheme, (default:unchanged)

- Color (default)
- Color (classic)
- Grayscale
- Inverse Grayscale

Sets visual properties for a track or channel (or both). SpectralPrefs=1 sets the track to use general preferences, SpectralPrefs=1 per track prefs. When using general preferences, SetPreferences can be used to change a preference and so affect display of the track.

GetPreference: | Get Preference... | string Name, (default:) | Gets a single preference setting.
SetPreference: | Set Preference... | string Name, (default:) string Value, (default:) bool Reload, (default:False) | Sets a single preference setting. Some settings such as them changes require a reload (use Reload=1), but this takes time and slows down a script.

SetClip:

Set Clip...

double At, (default:unchanged)

enum Color, (default:unchanged)

- Color0
- Color1
- Color2
- Color3

double Start, (default:unchanged)

Modify a clip by stating the track or channel a time within it. Color and start position can be set. Try to avoid overlapping clips, as Audacity will allow it, but does not like them.

SetEnvelope: | Set Envelope... | double Time, (default:unchanged) double Value, (default:unchanged) bool Delete, (default:unchanged) | Modify an envelope by specifying a track or channel and a time within it. You cannot yet delete individual envelope points, but can delete the whole envelope using Delete=1.
SetLabel: | Set Label... | int Label, (default:0) string Text, (default:unchanged) double Start, (default:unchanged) double End, (default:unchanged) bool Selected, (default:unchanged) | Modifies an existing label. You must give it the label number.
SetProject: | Set Project... | string Name, (default:unchanged) double Rate, (default:unchanged) int X, (default:unchanged) int Y, (default:unchanged) int Width, (default:unchanged) int Height, (default:unchanged) | Sets the project window to a particular location and size. Can also change the caption - but that is cosmetic and may be overwritten again later by Audacity.

### Extra: Scriptables II

Like Scriptables I, but these ones are less commonly used from the menu.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---

Select:

Select...

double Start, (default:unchanged)

double End, (default:unchanged)
enum RelativeTo, (default:unchanged)

- ProjectStart
- Project
- ProjectEnd
- SelectionStart
- Selection
- SelectionEnd

double High, (default:unchanged)
double Low, (default:unchanged)
double Track, (default:unchanged)
double TrackCount, (default:unchanged)
enum Mode, (default:unchanged)

- Set
- Add
- Remove

Selects audio. Start and End are time. First and Last are track numbers. High and Low are for spectral selection. FromEnd allows selection from the end, which is handy to fade in and fade out a track. The Mode parameter allows complex selections, e.g adding or removing tracks from the current selection.

SetTrack:

Set Track...

string Name, (default:unchanged)

bool Selected, (default:unchanged)
bool Focused, (default:unchanged)
bool Mute, (default:unchanged)
bool Solo, (default:unchanged)
double Gain, (default:unchanged)
double Pan, (default:unchanged)
int Height, (default:unchanged)
enum Display, (default:unchanged)

- Waveform
- Spectrogram

enum Scale, (default:unchanged)

- Linear
- dB

enum Color, (default:unchanged)

- Color0
- Color1
- Color2
- Color3

enum VZoom, (default:unchanged)

- Reset
- Times2
- HalfWave

double VZoomHigh, (default:unchanged)
double VZoomLow, (default:unchanged)
bool SpecPrefs, (default:unchanged)
bool SpectralSel, (default:unchanged)
bool GrayScale, (default:unchanged)

Sets properties for a track or channel (or both). Setting one channel of a stereo track can lead to interesting results. That's most used when setting relative sizing of the two channels. SpectralPrefs=1 sets the track to use general preferences, SpectralPrefs=1 per track prefs. When using general preferences, SetPreferences can be used to change a preference and so affect display of the track. Name is used to set the name. It is not used in choosing the track.

GetInfo:

Get Info...

enum Type, (default:Commands)

- Commands
- Menus
- Preferences
- Tracks
- Clips
- Envelopes
- Labels
- Boxes

enum Format, (default:JSON)

- JSON
- LISP
- Brief

Gets information in a list in one of three formats.

Message: | Message... | string Text, (default:Some message) | Used in testing. Sends the Text string back to you.

Help:

Help...

string Command, (default:Help)

enum Format, (default:JSON)

- JSON
- LISP
- Brief

This is an extract from GetInfo Commands, with just one command.

Import2: | Import... | string Filename, (default:) | Imports from a file. The automation command uses a text box to get the file name rather than a normal file-open dialog.

Export2:

Export...

string Filename, (default:exported.wav)

int NumChannels, (default:1)

Exports to a named file. This version of export has the full set of export options. However, a current limitation is that the detailed option settings are always stored to and taken from saved preferences. The net effect is that for a given format, the most recently used options for that format will be used. In the current implementation, NumChannels should be 1 (mono) or 2 (stereo).

OpenProject2: | Open Project... | string Filename, (default:test.aup3) bool AddToHistory, (default:false) | Opens a project.
SaveProject2: | Save Project... | string Filename, (default:name.aup3) bool AddToHistory, (default:False) bool Compress, (default:False) | Saves a project.

Drag:

Move Mouse...

int Id, (default:unchanged)

string Window, (default:unchanged)
double FromX, (default:unchanged)
double FromY, (default:unchanged)
double ToX, (default:unchanged)
double ToY, (default:unchanged)
enum RelativeTo, (default:unchanged)

- Panel
- App
- Track0
- Track1

Experimental command (called Drag in scripting) that moves the mouse. An Id can be used to move the mouse into a button to get the hover effect. Window names can be used instead. If To is specified, the command does a drag, otherwise just a hover.

CompareAudio: | Compare Audio... | float Threshold, (default:0) | Compares selected range on two tracks. Reports on the differences and similarities.
Screenshot: | Screenshot (short format)... | none | A version of Tools -> Screenshot with a more minimal GUI. One of the most useful options is All_Tracks. The _Plus suffix includes the timeline.

## Help Menu

The Help Menu lets you find out more about the Audacity application and how to use it. It also includes some diagnostic tools.

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
QuickHelp: | Quick Help... | none | A brief version of help with some of the most essential information.
Manual: | Manual... | none | Opens the manual in the default browser.
Updates: | Check for Updates... | none | Checks online to see if this is the latest version of Audacity.
About: | About Audacity... | none | Brings a dialog with information about Audacity, such as who wrote it, what features are enabled and the GNU GPL v2 license.

### Help: Diagnostics

A set of diagnostic tools

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
DeviceInfo: | Audio Device Info... | none | Shows technical information about your detected audio device(s).
MidiDeviceInfo: | MIDI Device Info... | none | Shows technical information about your detected MIDI device(s).
Log: | Show Log... | none | Launches the "Audacity Log" window, the log is largely a debugging aid, having timestamps for each entry
CrashReport: | Generate Support Data... | none | Selecting this will generate a Debug report which could be useful in aiding the developers to identify bugs in Audacity or in third-party plug-ins
CheckDeps: | Check Dependencies... | none | Lists any WAV or AIFF audio files that your project depends on, and allows you to copy these files into the project

## No Menu

These are additional commands that do not appear in any menu

Scripting Id | Action | Parameters | Description
--- | --- | --- | ---
PrevWindow: | Previous Window | none | Navigates to the previous window.
NextWindow: | Next Window | none | Navigates to the next window.